var mOnFire = require("./other/onfire.js");
var $aliBlufiImpl = require("./xBlufi-ali-impl.js"); // 支付宝小程序实现
var $wxBlufiImpl = require("./xBlufi-wx-impl.js"); // 微信小程序实现

let XMQTT_SYSTEM = {
  Alis: 0,  // 支付宝小程序
  WeChat: 1 // 微信小程序
};

let XBLUFI_TYPE = {
  TYPE_STATUS_CONNECTED: '-2',
  TYPE_CLOSE_CONNECTED: '-1',
  TYPE_CONNECTED: '0',
  TYPE_GET_DEVICE_LISTS: '1',
  TYPE_INIT_ESP32_RESULT: '2',
  TYPE_RECIEVE_CUSTON_DATA: '3',
  TYPE_CONNECT_ROUTER_RESULT: '4',
  TYPE_RECIEVE_MY_DATA: '5', 
  TYPE_GET_DEVICE_LISTS_START: '41',
  TYPE_GET_DEVICE_LISTS_STOP: '42'
};

let OnFireEvent = {
  EVENT_START_DISCONORY: '0',
  EVENT_CONNECT_DISCONNECT: '1',
  EVENT_NOFITY_INIT_ESP32: '3',
  ENENT_ALL: '6',
  EVENT_NOFITY_SEND_ROUTER_SSID_PASSWORD: '50',
  EVENT_NOFITY_SEND_CUSTON_DATA: '51'
};

let once = 0;
function initXBlufi(type) {
  switch (type) {
    case XMQTT_SYSTEM.Alis:
      if(once == 0) {
        once = 1;
        $aliBlufiImpl.init(); // 初始化支付宝蓝牙实现
      }
      break;
    case XMQTT_SYSTEM.WeChat:
      if(once == 0) {
        once = 1;
        $wxBlufiImpl.init();
      }
      break;
  }
}

let my_path = '';
function set_path(type) {
  my_path = type;
}

function get_path() {
  return my_path;
}

function notifyDeviceMsgEvent(options) {
  mOnFire.fire(OnFireEvent.ENENT_ALL, options);
}

function listenDeviceMsgEvent(isSetListener, funtion) {
  if (isSetListener) {
    mOnFire.on(OnFireEvent.ENENT_ALL, funtion);
  } else {
    mOnFire.un(funtion);
  }
}

function notifyStartDiscoverBle(options) {
  mOnFire.fire(OnFireEvent.EVENT_START_DISCONORY, options);
}

function listenStartDiscoverBle(isSetListener, funtion) {
  if (isSetListener) {
    mOnFire.on(OnFireEvent.EVENT_START_DISCONORY, funtion);
  } else {
    mOnFire.un(funtion);
  }
}

function notifyConnectBle(options) {
  mOnFire.fire(OnFireEvent.EVENT_CONNECT_DISCONNECT, options);
}

function listenConnectBle(isSetListener, funtion) {
  if (isSetListener) {
    mOnFire.on(OnFireEvent.EVENT_CONNECT_DISCONNECT, funtion);
  } else {
    mOnFire.un(funtion);
  }
}

function notifyInitBleEsp32(options) {
  mOnFire.fire(OnFireEvent.EVENT_NOFITY_INIT_ESP32, options);
}

function listenInitBleEsp32(isSetListener, funtion) {
  if (isSetListener) {
    mOnFire.on(OnFireEvent.EVENT_NOFITY_INIT_ESP32, funtion);
  } else {
    mOnFire.un(funtion);
  }
}

function notifySendRouterSsidAndPassword(options) {
  mOnFire.fire(OnFireEvent.EVENT_NOFITY_SEND_ROUTER_SSID_PASSWORD, options);
}

function listenSendRouterSsidAndPassword(isSetListener, funtion) {
  if (isSetListener) {
    mOnFire.on(OnFireEvent.EVENT_NOFITY_SEND_ROUTER_SSID_PASSWORD, funtion);
  } else {
    mOnFire.un(funtion);
  }
}

function notifySendCustomData(options) {
  mOnFire.fire(OnFireEvent.EVENT_NOFITY_SEND_CUSTON_DATA, options);
}

function listenSendCustomData(isSetListener, funtion) {
  if (isSetListener) {
    mOnFire.on(OnFireEvent.EVENT_NOFITY_SEND_CUSTON_DATA, funtion);
  } else {
    mOnFire.un(funtion);
  }
}

module.exports = {
  XMQTT_SYSTEM,
  XBLUFI_TYPE,
  OnFireEvent,
  notifyDeviceMsgEvent,
  listenDeviceMsgEvent,
  notifyStartDiscoverBle,
  listenStartDiscoverBle,
  notifyConnectBle,
  listenConnectBle,
  notifyInitBleEsp32,
  listenInitBleEsp32,
  notifySendRouterSsidAndPassword,
  listenSendRouterSsidAndPassword,
  notifySendCustomData,
  listenSendCustomData,
  initXBlufi,
  set_path,
  get_path
};